/**
  * Klasse Lampe
  * @version 2015-12-17
  * @author  T. Hempel
  */

public class Lampe {

  // Anfang Attribute
  private boolean zustand;
  private int nummer;
  // Ende Attribute
  
  /**
  * Konstruktor
  * @param pNummer Nummer der LED
  */
  public Lampe(int pNummer) {
    zustand = false;
    nummer = pNummer;
    hardware.ledOff(nummer);
  }
  
  // Anfang Methoden
  
  /**
  * Methode zum Einschalten
  */
  public void einschalten() {
    zustand = true;
    hardware.ledOn(nummer);
  }
  
  /**
  * Methode zum Ausschalten
  */
  public void ausschalten() {
    zustand = false;
    hardware.ledOff(nummer);
  }
  
  /**
  * Methode zum Rckgeben des Zustands der Lampe
  * @return zustand
  */
  public boolean getZustand() {
    return zustand;
  }
  
  /**
  * Methode zum Rckgeben der Lampennummer
  * @return nummer
  */
  public int getNummer() {
    return nummer;
  }
  
  // Ende Methoden
  
}
